package com.ruoyi.bst.credit.service;

import java.math.BigDecimal;
import java.util.List;

import com.ruoyi.bst.credit.domain.Credit;
import com.ruoyi.bst.credit.domain.CreditQuery;
import com.ruoyi.bst.credit.domain.CreditVO;

/**
 * 挂账方Service接口
 *
 * @author ruoyi
 * @date 2025-05-27
 */
public interface CreditService
{
    /**
     * 查询挂账方
     *
     * @param id 挂账方主键
     * @return 挂账方
     */
    public CreditVO selectCreditById(Long id, boolean scope);

    default CreditVO selectCreditById(Long id) {
        return selectCreditById(id, false);
    }

    /**
     * 查询挂账方列表
     *
     * @param credit 挂账方
     * @return 挂账方集合
     */
    public List<CreditVO> selectCreditList(CreditQuery credit);

    /**
     * 新增挂账方
     *
     * @param credit 挂账方
     * @return 结果
     */
    public int insertCredit(Credit credit);

    /**
     * 修改挂账方
     *
     * @param credit 挂账方
     * @return 结果
     */
    public int updateCredit(Credit credit);

    /**
     * 逻辑删除挂账方
     *
     * @param ids 需要删除的挂账方主键集合
     * @return 结果
     */
    public int logicDel(List<Long> ids);

    /**
     * 增加已用金额
     * @param id
     * @param amount
     */
    public int addUsedAmount(Long id, BigDecimal amount);
}
